/***************************************************************************
                                konfigurator.h
                             -------------------
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
  Description
 ***************************************************************************

  A

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     H e a d e r    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KONFIGURATOR_H
#define KONFIGURATOR_H

#include <qwidget.h>
#include <kfontdialog.h>
#include <kdialogbase.h>
#include <kjanuswidget.h>
#include <qframe.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qcolor.h>
#include <kcolorbtn.h>
#include "krdialogs.h"
#include <qspinbox.h>


class Konfigurator : public KDialogBase  {
   Q_OBJECT

   enum Tab {
      General     = 0,
      LookNFeel   = 1,
      External    = 2,
      Advanced    = 3,
      Information = 4
   };

public:
	Konfigurator();
	~Konfigurator();

protected:
  void createLayout();
  void createGeneral();
  void createLookNFeel();
  void createExternal();
  void createAdvanced();

protected slots:
  void slotOk();
  void slotApply();   // actually used for defaults
  void slotCancel();
  // general
  void leftPanelBrowse();
  void rightPanelBrowse();
  // look & feel
  void menuBarFontBrowse();
  void fileListFontBrowse();
  void cmdLineFontBrowse();
  void historyFontBrowse();
  void fnKeysFontBrowse();
  void bookmarkFontBrowse();
  // external
  void editorBrowse();
  void terminalBrowse();
  void tarBrowse();
  void zipBrowse();
  void unzipBrowse();
  void bzip2Browse();
  void arjBrowse();
  void rarBrowse();
  void gzipBrowse();
  void checkZipStatus();

private:
  QFrame *general,*looknfeel,*external,*advanced,*information;
  KJanusWidget *widget;
  KChooseDir *dirBrowser;
  KFontDialog *fontBrowser;
  /////////////// these belong to the janus widget ///////////
  // General
  QCheckBox *G_markDirs,*G_useMagic,*G_showHidden,*G_rememberPos; //!
  QLineEdit *G_leftOrigin,*G_rightOrigin;                         //!
  QPushButton *G_leftOriginBrowse, *G_rightOriginBrowse;
  QButtonGroup *G_whosTheTree;
  QRadioButton *G_leftTree,*G_rightTree,*G_noTree;                //!
  QCheckBox *G_splashScreen;                                      //!
  // Look & Feel
  	// fonts
  QLabel *L_bookmarkFontD,*L_menuFontD,*L_fileListFontD,*L_cmdLineFontD,*L_historyFontD,*L_fnKeysFontD;
  QPushButton *L_bookmarkFontB,*L_menuFontB,*L_fileListFontB,*L_cmdLineFontB,*L_historyFontB,*L_fnKeysFontB;
  QFont *L_bookmarkFont,*L_menuFont,*L_fileListFont,*L_cmdLineFont,*L_historyFont,*L_fnKeysFont;  //!
		// colors
	KColorButton *L_originBkg,*L_originText,*L_statusBkg,*L_statusText; //!
	// External
	QLineEdit *E_editor,*E_terminal,*E_execSwitch;
	QPushButton *E_editorBrowse,*E_terminalBrowse;
	QCheckBox *E_doTAR,*E_doGZIP,*E_doBZIP2,*E_doARJ,*E_doRAR,*E_doZIP,*E_doUnZIP;
	QLineEdit *E_tar,*E_zip,*E_unzip,*E_gzip,*E_bzip2,*E_arj,*E_rar;
	QPushButton *E_tarBrowse,*E_zipBrowse,*E_unzipBrowse,*E_gzipBrowse,*E_bzip2Browse,*E_arjBrowse,*E_rarBrowse;
	// Advanced
	QCheckBox *A_cUnemptyDir, *A_moveIntoArchive, *A_permCheck, *A_autoMount;
  QSpinBox *A_iconCache;
  QButtonGroup *A_konfigurator;
  QRadioButton *A_asTab, *A_asTree;
};

#endif

