/***************************************************************************
                                krdialogs.cpp
                             -------------------
    Version							 : Milestone 1
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
  Description 
 ***************************************************************************

  A 

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     S o u r c e    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


// Krusader includes
#include "krdialogs.h"
// QT includes
#include <qmessagebox.h>
#include <qwidget.h>
#include <qapplication.h>
// KDE includes
#include <klocale.h>
#include <kapp.h>

#include "krusader.h"

KRDialog::KRDialog(QWidget *parent, QString text,bool modal, bool roomForIcon) :
					KDialog(parent,0,modal,WStyle_DialogBorder) {
	layout=new QGridLayout(this,1,1,5); 	// 1,1 makes the grid auto-resize when needed
	message=new QLabel(text,this);
	layout->addMultiCellWidget(message,0,0,0+(int)roomForIcon,10); // why 10 ?? check KQuestion::KQuestion
	layout->activate();
	setMaximumSize(minimumSize());
}	


QString KQuestion::answear;

KChooseDir::KChooseDir(QWidget *parent, QString quest,QString url) :
						KQuestion(parent, quest){
//*	QPushButton *ok, *cancel,
    QPushButton *brw;
//*	QLabel *label;
	
	answear=url;
	line->setText(answear);	

	brw = new QPushButton( i18n("&Browse"), this );
	// the ok and cancel buttons are at (2,0) and (2,1);
	layout->addWidget(brw,2,3);
	layout->activate();							// update the layout
	connect( brw, SIGNAL(clicked()),this, SLOT(browse()) );
}


void KChooseDir::browse(){
	// open a open directory window
	QString temp =  KFileDialog::getExistingDirectory(answear,0,i18n("Please select a directory"));
  if (temp != QString::null){
			answear=temp;
			line->setText(answear);
	}
}

KQuestion::KQuestion(QWidget *parent, QString quest, QString defAnswer):
           KRDialog(parent, quest,true,true) {
	QPushButton *ok, *cancel;
	QLabel *iconSpace;
	
	answear=QString::null;	

	ok = new QPushButton( i18n("&OK"), this );
	ok->setDefault(true);
	connect( ok, SIGNAL(clicked()),this, SLOT(accept()) );
	
	cancel = new QPushButton( i18n("&Cancel"), this );
	connect( cancel, SIGNAL(clicked()),this, SLOT(reject()) );
	
	line = new QLineEdit(this);
	line->setText(defAnswer);
	connect( line, SIGNAL(returnPressed()), this, SLOT(accept()) );

	// keeping in mind that KRDialog already placed "quest" in cell (0,0)...
	// add ok and cancel side-by-side (y,x)!
	layout->addWidget(ok,2,1); layout->addWidget(cancel,2,2);
	layout->addMultiCellWidget(line,1,1,0,10);	
		// 10 is obviously too much but just in case we add many buttons...
	// create a pixmap
	iconSpace=new QLabel(this);
	iconSpace->setPixmap(QMessageBox::standardIcon(QMessageBox::Information,Qt::PMStyle));
	// now, add space for the pixmap
	layout->addWidget(iconSpace,0,0);
	line->setFocus();
	layout->activate();
}

// this box is displayed as long as the files are being read
// the box is created on-top and centered on screen.
////////////////////////////////////////////////////////////
KReadVFS::KReadVFS(int max):
  QProgressDialog(0,0,max,this,0,false,WStyle_StaysOnTop) {
  setLabelText("Reading filesystem...");
  setCaption(i18n(" Please Wait "));
  setProgress(0);
  setMinimumDuration(2000);
  show();
}

void KRprogress::initKRprogress(){
  // wow - look at all those conections:
  connect(parent,SIGNAL(percent ( KIO::Job*, unsigned long)),
          this,SLOT(slotPercent(KIO::Job*,unsigned long)) );
  connect(parent,SIGNAL(totalSize(KIO::Job*,unsigned long)),
          this,SLOT(slotTotalSize(KIO::Job *,unsigned long)));
  connect(parent,SIGNAL(processedSize(KIO::Job*, unsigned long)),
          this,SLOT(slotProcessedSize(KIO::Job *,unsigned long)));
  connect(parent,SIGNAL(speed(KIO::Job*,unsigned long)),
          this,SLOT(slotSpeed(KIO::Job *,unsigned long)));
  connect(parent,SIGNAL(totalFiles ( KIO::Job*,unsigned long)),
          this,SLOT(slotTotalFiles(KIO::Job *,unsigned long)));
  connect(parent,SIGNAL(processedFiles(KIO::Job*,unsigned long)),
          this,SLOT(slotProcessedFiles(KIO::Job *,unsigned long)));
  connect(parent,SIGNAL(deleting ( KIO::Job*, const KURL&)),
          this,SLOT(slotDeleting(KIO::Job *,const KURL&)));
  connect(parent,SIGNAL(copying (KIO::Job*, const KURL& , const KURL& )),
          this,SLOT(slotCopying(KIO::Job *,const KURL& , const KURL& )));
  connect(parent,SIGNAL(moving(KIO::Job*, const KURL& , const KURL&  )),
          this,SLOT(slotMoving(KIO::Job *,const KURL& , const KURL&  )));
  connect(parent,SIGNAL(infoMessage (KIO::Job*, const QString & )),
          this,SLOT(slotInfoMessage(KIO::Job *,const QString & )));
  connect(parent,SIGNAL(result(KIO::Job*)),
          this,SLOT(close()));

  reparent(krApp,WType_Modal,QPoint());
  setGeometry(krApp->width()/2-200,krApp->height()/2-height()/2,400,height());
  show();
}

KRprogress::KRprogress(QObject* par):
  DefaultProgress(false),parent(par){
  initKRprogress();
}

KRprogress::KRprogress(KIO::Job* job):
  DefaultProgress(false){
  parent = (QObject*)job;
  setJob(job);
  initKRprogress();
}

void KRprogress::slotCopying( KIO::Job*, const KURL& from, const KURL& to ){
  setCaption(i18n("Krusader - Copy file(s) progress"));
  mode = Copy;
  sourceLabel->setText( shortUrl(from) );
  destLabel->setText( shortUrl(to) );
}


void KRprogress::slotMoving( KIO::Job*, const KURL& from, const KURL& to ){
  setCaption(i18n("Krusader - Move file(s) progress"));
  mode = Move;
  sourceLabel->setText( shortUrl(from) );
  destLabel->setText( shortUrl(to) );
}

void KRprogress::slotDeleting( KIO::Job*, const KURL& url ){
  setCaption(i18n("Krusader - Delete file(s) progress"));
  mode = Delete;
  sourceLabel->setText( shortUrl(url) );
}

QString KRprogress::shortUrl(KURL url){
  QString s = url.path();
  if( s.length() < 42 ) return s;
  s = s.right(39);
  s.remove(0,s.find('/'));
  if (s.length() < 5 ) s = url.path().right(40);
  return ".."+s;
}
