/***************************************************************************
                                krdialogs.h
                             -------------------
    Version							 : Milestone 1
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
  Description: the krusader dialogs and popup boxes are stored here
 ***************************************************************************

  A

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     H e a d e r    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KCHOSEDIR_H
#define KCHOSEDIR_H

// KDE includes
#include <kdialog.h>
#include <kfiledialog.h>
#include <defaultprogress.h>
// QT includes
#include <qlineedit.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qpixmap.h>
#include <qprogressdialog.h>
#include <qsemimodal.h>
// Krusader includes
#include <kicons.h>

#include <iostream>

// the most basic dialog in krusader.
class KRDialog : public KDialog {
	Q_OBJECT
public:
	KRDialog(QWidget *parent = 0, QString text = 0,bool modal=true, bool roomForIcon=false);

protected:
	QGridLayout *layout;		
	QLabel 			*message;
};

// a simple dialog which ask a question, retrun the user answer
// in the static QString answear or QString::null if the user pressed
// the cancel button
class KQuestion : public KRDialog {
	Q_OBJECT
public:	
	KQuestion(QWidget *parent, QString quest, QString defAnswer = "");

public slots:
	void reject(){ answear=QString::null;KDialog::reject(); }
	void accept(){ answear=line->text();KDialog::accept(); }

public:
	static QString answear;
	
protected:
	QLineEdit *line;

};

// an extension to KQuestion that adds a browse
// button which open a directory selector
class KChooseDir : public KQuestion{
	Q_OBJECT	
public:
	KChooseDir(QWidget *parent, QString quest,QString url);

public slots:
	void browse();
};

class KReadVFS : public QProgressDialog {
public:
	KReadVFS(int max);
};

class KRprogress : public DefaultProgress {
  Q_OBJECT
public:
  KRprogress(QObject* parent);
  KRprogress(KIO::Job* parent);

public slots:
  void slotCopying( KIO::Job*, const KURL& from, const KURL& to );
  void slotMoving( KIO::Job*, const KURL& from, const KURL& to );
  void slotDeleting( KIO::Job*, const KURL& url );
  QString shortUrl(KURL url);

protected:
  void initKRprogress();
  QObject* parent;
};




#endif
