/***************************************************************************
                                krlistitem.cpp
                             -------------------
    Version							 : Milestone 1
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
  Description 
 ***************************************************************************

  A 

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     S o u r c e    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "krlistitem.h"
#include <ctype.h>
#include <iostream>
#include <qregexp.h>

QString num2qstring(long num){
  QString temp;
  temp.sprintf("%015ld",num);
  return temp;
}

QString date2qstring(QString date){
  QString temp;
  int year;

  year = date[6].digitValue()*10+date[7].digitValue();
  year > 80 ? year+=1900 : year += 2000;

  temp.sprintf("%d",year);
  temp= temp+date[3]+date[4]+date[0]+date[1]+date[9]+date[10]+date[12]+date[13];

  return temp;
}

QString KRListItem::key ( int column, bool ascending ) const {
//  return text(column);

    if (text(0)==".."){
      if (ascending) return "";
      else return "zzzzzzzzzzzzz";
    }
    if ( text(1)=="<DIR>"){
     if(ascending) return text(0);
     else return "zzzzzzzzzz"+text(0);
    }

    if (column == 0) return "zzzz"+text(0);
    if (column == 1) return "zzzz"+num2qstring(text(1).replace(QRegExp(","),"").toLong());
    if (column == 2) return "zzzz"+date2qstring(text(2));
    return "";
}

KRListItem::~KRListItem(){
}

void KRListItem::paintCell(QPainter *p,const QColorGroup & cg,int column,int width,int align){
  if( column == 1 && text(1) == "<DIR>" )
    align = Qt::AlignHCenter;  // center the <DIR> text...
  QListViewItem::paintCell(p,cg,column,width,align);
}
