/***************************************************************************
                                krusader.h
                             -------------------
    Version							 : Milestone 1
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
 The main application ! what's more to say ?
 ***************************************************************************

  A

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     H e a d e r    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KRUSADER_H
#define KRUSADER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// KDE includes
#include <kapp.h>
#include <ktmainwindow.h>
#include <kconfig.h>

// Krusader includes
#include "krusadermenu.h"
#include "krusaderview.h"
#include "kvfspanel.h"
#include "resources.h"
#include "krusaderstatus.h"
#include "krusadertoolbar.h"
#include "kmountman.h"
#include "splashscreen.h"
#include "konfigurator.h"

#define krApp    Krusader::App
#define krConfig Krusader::App->config
#define krMtMan  Krusader::App->mountMan

class Krusader : public KTMainWindow
{
  Q_OBJECT

public:
  Krusader();
  ~Krusader();
 	void disableFutureItems(); // disable the menu for features not implemented
  void toggleToolButton(int id,bool on); 	

protected:
  bool queryClose() { saveSettings(); return true; }
public slots:
	// the menu Callback functions
  void slotFilesCallback(int id_);
  void slotMarkCallback(int id_);
  void slotCommandsCallback(int id_);
  void slotViewCallback(int id_);
  void slotToolsCallback(int id_);
  void slotOptionsCallback(int id_);
	// the status line slot
  void slotStatusCallback(int id_);
	void statusBarUpdate(QString mess);
	
  // directory list functions
  inline void home()   { mainView->activePanel->home(); }
	inline void root()   { mainView->activePanel->slotPanelRefresh("/"); }
  inline void dirUp()  { mainView->activePanel->dirUp(); }
  inline void markAll(){ mainView->activePanel->selectAll(); }
	inline void unmarkAll(){ mainView->activePanel->unselectAll(); }
  inline void markGroup(){ mainView->activePanel->selectGroup(); }	
  inline void unmarkGroup(){ mainView->activePanel->unselectGroup(); }	
	inline void invert() { mainView->activePanel->invertSelection();}
  inline void refresh(){ mainView->activePanel->slotPanelRefresh(); }
  inline void properties(){ mainView->activePanel->slotFileProperties(); }

  // general
  void search();						 				// call the search module	
  void runKonfigurator() { new Konfigurator(); }
  void addBookmark();
  void runMountMan();
  // in use by Krusader only
  void saveSettings();
		
public:
  static Krusader* App;     // a kApp style pointer
  KMountMan mountMan;	      // krusader's Mount Manager
  KrusaderView   *mainView;
  KConfig        *config;   // allow everyone to access the config

private:
  KrusaderStatus *status;
  KrusaderMenu   *mainMenu;
	KrusaderToolBar*toolbar;
};

#endif
