/***************************************************************************
                                krusaderview.h
                             -------------------
    Version							 : Milestone 1
    begin                : Thu May 4 2000
    copyright            : (C) 2000 by Shie Erlich & Rafi Yanai
 ---------------------------------------------------------------------------
  Description
 ***************************************************************************

  A

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     H e a d e r    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KRUSADERVIEW_H
#define KRUSADERVIEW_H

// KDE includes
#include <klistview.h>
#include <klocale.h>
#include <kaccel.h>
#include <kapp.h>

// QT includes
#include <qlayout.h>
#include <qwidget.h>
#include <qpushbutton.h>

// Krusader includes
#include "kvfspanel.h"
#include "kcmdline.h"
#include "kfnkeys.h"

// forward declaration
class KFnKeys;

class KrusaderView : public QWidget  {
   Q_OBJECT

public:
	KrusaderView(QWidget *parent=0, const char *name=0);
	~KrusaderView(){}
	void setListView();
	void setTreeView();
	
private:
  void bindKeys();
  	
public slots:
  void slotCurrentChanged(QString p);
	inline void slotSetActivePanel(KVFSPanel *p) { activePanel=p; }
	// manage the function keys to the CURRENT vfs
	//////////////////////////////////////////////
	// F3
	inline void slotTerminal() { activePanel->slotTerm(); }
	// F4
	inline void slotEditFile() { activePanel->slotEditFile(); }
	// F5
	inline void slotCopyFiles() { activePanel->slotCopyFiles(); }
	// F6
	inline void slotMoveFiles() { activePanel->slotMoveFiles(); }	
	// F7
	inline void slotMkdir() { activePanel->slotMkDir(); }
	// F8
	inline void slotDeleteFiles() { activePanel->slotDeleteFiles(); }     	
	// F9
	inline void slotRenameFile() { activePanel->slotRenameFile(); }
  // Backspace - dir up
  inline void panelDirUp() { activePanel->dirUp(); }
  // Tab - switch focus
  inline void panelSwitch(){ activePanel->otherPanel->slotFocusOnMe(); }

public:
  KVFSPanel	  *activePanel;
  KVFSPanel	  *left,*right;								// the actual panels

private:
  QGridLayout *mainLayout;								// the main layout
	KFnKeys			*fnKeys;										// function keys
  KAccel      *keys;                      // other key bindings
  QSplitter		*splitter;									// splits the main window
  KCMDLine    *cmdLine;                   // command line widget
};

#endif
