/***************************************************************************
                                splashscreen.cpp
                             -------------------

    copyright            : (C) 1999 by Henrik Stormer
    email                : stormer@ifi.unizh.ch
 ***************************************************************************

  A 

     db   dD d8888b. db    db .d8888.  .d8b.  d8888b. d88888b d8888b.
     88 ,8P' 88  `8D 88    88 88'  YP d8' `8b 88  `8D 88'     88  `8D
     88,8P   88oobY' 88    88 `8bo.   88ooo88 88   88 88ooooo 88oobY'
     88`8b   88`8b   88    88   `Y8b. 88~~~88 88   88 88~~~~~ 88`8b
     88 `88. 88 `88. 88b  d88 db   8D 88   88 88  .8D 88.     88 `88.
     YP   YD 88   YD ~Y8888P' `8888Y' YP   YP Y8888D' Y88888P 88   YD

                                                     S o u r c e    F i l e

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "splashscreen.h"
#include <kapp.h>
#include <qpainter.h>
#include <qimage.h>

SplashScreen::SplashScreen(QWidget *parent, const char *name, QString Pic, QString Message)
 : QSemiModal(parent,name,false,WStyle_NoBorder|WStyle_Customize),
   _Message(Message)
{
  if (Pic)
  {
    QPixmap pm;
    pm.load(Pic);
    setBackgroundPixmap(pm);
    _width = pm.width();
    _height = pm.height();
  }
  else
  {
    QFontMetrics FMetrics(font());
    _width = FMetrics.width(_Message, Message.length()) + 50;
    _height = FMetrics.height() + 50;
  }

  QWidget* par = parent;
  if(par == 0) par = QApplication::desktop();

  setGeometry(par->width()/2-(_width/2),
              par->height()/2-(_height/2),
              _width, _height);

  update();
}

SplashScreen::~SplashScreen()
{
}

void SplashScreen::timeout()
{
  raise();
  qApp->processEvents(5000);
  close();
}


void SplashScreen::paintEvent( QPaintEvent * )
{
  if (_Message != NULL)
  {
    QPainter p;
    p.begin( this );                        // start painting widget
    p.setPen( black );
    //  p.setBrush(  );
    p.drawRect( 1,1, _width-1,_height-1 );
    p.drawText(25, 25, _Message);
    p.end();
  }
}










